/* Server che ritorna un carattere ad una posizione richiesta in una stringa */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>

#define FILENAME_LENGTH 80
/********************************************************/

typedef struct
{
  char nomeFile[FILENAME_LENGTH];
  char car;
}
Request;


/********************************************************/

int main(int argc, char **argv)
{
  int  sd;
  int port, len, fd, ris, nread;  
  char ccorr;
  const int on = 1;
  struct sockaddr_in cliaddr, servaddr;
  struct hostent *clienthost;

  Request* req =(Request*)malloc(sizeof(Request));

  /* CONTROLLO ARGOMENTI ---------------------------------- */
  if(argc!=2)
  {
    printf("Error: %s port\n", argv[0]);
    exit(1);
  }
  /* Aggiungere verifica intero ... */
  else port = atoi(argv[1]);

  /* INIZIALIZZAZIONE INDIRIZZO SERVER ---------------------------------- */
  memset ((char *)&servaddr, 0, sizeof(servaddr));
  servaddr.sin_family = AF_INET;
  servaddr.sin_addr.s_addr = INADDR_ANY;  
  servaddr.sin_port = htons(port);  
  

  /* CREAZIONE, SETAGGIO OPZIONI E CONNESSIONE SOCKET -------------------- */
  sd=socket(AF_INET, SOCK_DGRAM, 0);
  if(sd <0)
  {perror("creazione socket "); exit(1);}
  printf("Server: creata la socket, sd=%d\n", sd);

  if(bind(sd,(struct sockaddr *) &servaddr, sizeof(servaddr))<0)
  {perror("bind socket "); exit(1);}
  printf("Server: bind socket ok\n");

  if(setsockopt(sd, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on))<0)
  {perror("set opzioni socket "); exit(1);}
  printf("Server: set opzioni socket ok\n");




  /* CICLO DI RICEZIONE RICHIESTE ------------------------------------------ */
  for(;;)
  {
    len=sizeof(struct sockaddr_in);
    if (recvfrom(sd, req, sizeof(Request), 0, (struct sockaddr *)&cliaddr, &len)<0)
    {perror("recvfrom "); continue;}	

    printf("Operazione richiesta, nome file: %s, carattere: %c\n", req->nomeFile, req->car);
    clienthost=gethostbyaddr( (char *) &cliaddr.sin_addr, sizeof(cliaddr.sin_addr), AF_INET);
    if (clienthost == NULL) printf("client host information not found\n");
	else printf("Operazione richiesta da: %s %i\n", clienthost->h_name,
      (unsigned)ntohs(cliaddr.sin_port)); 

    /* Verifico l'esistenza del file */
    if((fd=open(req->nomeFile, O_RDONLY))<0)
    {
      perror("open file sorgente");
      ris=-1;
    }
    else{
      ris=0;
      while((nread=read(fd, &ccorr, 1))>0)
      {
        if(ccorr==req->car) ris++;
      }
    }
    
    
    // DEBUG
    printf("Risposta: %d\n", ris);
    ris=htonl(ris);

    if (sendto(sd, &ris, sizeof(ris), 0, (struct sockaddr *)&cliaddr, len)<0)
    {perror("sendto "); continue;}

  } /* ciclo for */

}

